### Name: xsample
### Title: Randomly samples an under- or overdetermined problem with linear
###   equality and inequality conditions
### Aliases: xsample
### Keywords: algebra array optimize

### ** Examples
# Sample the underdetermined Mink diet problem
E <- rbind(Minkdiet$Prey,rep(1,7))
F <- c(Minkdiet$Mink,1)

pairs(xsample(E=E,F=F,G=diag(7),H=rep(0,7),iter=5000,output=1000,type="cda")$X,
     main="Minkdiet 1000 solutions, - cda")

# sample the overdetermined Chemtax problem
Nx     <-nrow(Chemtax$Ratio)
  
# equations that have to be met exactly Ex=f: 
# sum of all fraction must be equal to 1.
E <- rep(1,Nx)
F <- 1
  
# inequalities, Gx>=h:
# all fractions must be positive numbers
G <- diag(nrow=Nx)
H <- rep(0,Nx)
  
# equations that must be reproduced as closely as possible, Ax ~ b
# the field data; the input ratio matrix and field data are rescaled
A     <- t(Chemtax$Ratio/rowSums(Chemtax$Ratio))
B     <- Chemtax$Field/sum(Chemtax$Field)
  
# Sample
xs <- xsample(A=A,B=B,E=E,F=F,G=G,H=H,iter=2000,outputlen=1000)$X
pairs(xs, main="Chemtax 1000 solutions - 2000 iterations")

     


