###################################################
### chunk number 1: preliminaries
###################################################
library("limSolve")
options(prompt = "> ")



###################################################
### chunk number 2: even determined
###################################################
E <- matrix(nrow=3,ncol=3,
            data=c(3,1,2,2,0,0,1,0,2))
F <- c(2,1,8)

solve(E,F)
Solve(E,F)


###################################################
### chunk number 3: even determined2
###################################################
E2 <- rbind(E,E[1,]+E[2,])
F2 <- c(F,F[1]+F[2])

#solve(E2,F2) # error
Solve(E2,F2)


###################################################
### chunk number 4: over no ineq
###################################################
A <- matrix(nrow=4,ncol=3,
            data=c(3,1,2,0,2,0,0,1,1,0,2,0))
B <- c(2,1,8,3)

lsei(A=A,B=B,fulloutput=TRUE)


###################################################
### chunk number 5: over2
###################################################
Solve(A,B)


###################################################
### chunk number 6: over with ineq
###################################################
G <- matrix(nrow=2, ncol=3, byrow=TRUE,
            data=c(-1,2,0,1,0,-1))
H <- c(-3,2)

lsei(A=A,B=B,G=G,H=H)


###################################################
### chunk number 7: u1a
###################################################
E <- matrix(nrow=2, ncol=3,
            data=c(3,1,2,0,1,0))
F <- c(2,1)

Solve(E,F)
ldei(E=E,F=F)$X


###################################################
### chunk number 8: 
###################################################
lsei(E=E,F=F,A=diag(3),B=rep(0,3))$X


###################################################
### chunk number 9: u1b
###################################################
xs <- xsample(E=E,F=F,iter=500)$X
plot(xs[,2],xs[,3])


###################################################
### chunk number 10: figu1b
###################################################
xs <- xsample(E=E,F=F,iter=500)$X
plot(xs[,2],xs[,3])


###################################################
### chunk number 11: 
###################################################
E <- matrix(ncol=4, byrow=TRUE,
            data=c(3,2,1,4,1,1,1,1))
F <- c(2,2)

G <-matrix(ncol=4,byrow=TRUE,
           data=c(2,1,1,1,-1,3,2,1,-1,0,1,0))
H <- c(-1, 2, 1)
ldei(E,F,G=G,H=H)$X
(pars<-lsei(E,F,G=G,H=H,A=diag(nrow=4),B=rep(0,4))$X)


###################################################
### chunk number 12: 
###################################################
(xr<-xranges(E,F,G=G,H=H))


###################################################
### chunk number 13: dc
###################################################
dotchart(pars,xlim=range(c(pars,xr)),label=paste("x",1:4,""))
segments(x0=xr[,1],x1=xr[,2],y0=1:nrow(xr),y1=1:nrow(xr))


###################################################
### chunk number 14: figdc
###################################################
dotchart(pars,xlim=range(c(pars,xr)),label=paste("x",1:4,""))
segments(x0=xr[,1],x1=xr[,2],y0=1:nrow(xr),y1=1:nrow(xr))


###################################################
### chunk number 15: 
###################################################
xs <- xsample(E=E,F=F,G=G,H=H,type="cda")$X


###################################################
### chunk number 16: u2
###################################################
panel.dens <- function(x, ...)
{
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(usr[1:2], 0, 1.5) )
    DD <- density(x); DD$y<- DD$y/max(DD$y)
    polygon(DD,col="grey")
}
pairs(xs,pch=".",cex=2,upper.panel=NULL,diag.panel=panel.dens)


###################################################
### chunk number 17: figu2
###################################################
panel.dens <- function(x, ...)
{
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(usr[1:2], 0, 1.5) )
    DD <- density(x); DD$y<- DD$y/max(DD$y)
    polygon(DD,col="grey")
}
pairs(xs,pch=".",cex=2,upper.panel=NULL,diag.panel=panel.dens)


###################################################
### chunk number 18: 
###################################################
Va<-c(1,2,-1,1)
Vb<- -2
varranges(E,F,G=G,H=H,EqA=Va,EqB=Vb)
summary(varsample(xs,EqA=Va,EqB=Vb))


###################################################
### chunk number 19: lsei2
###################################################
A <- matrix(ncol=4, byrow=TRUE,
            data=c(2,2,1,6,1,-1,1,-1))
B <- c(1,2)

lsei(E,F,G=G,H=H,A=A,B=B)$X


###################################################
### chunk number 20: u3
###################################################
panel.dens <- function(x, ...)
{
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(usr[1:2], 0, 1.5) )
    DD <- density(x); DD$y<- DD$y/max(DD$y)
    polygon(DD,col="grey")
}
xs <- xsample(E=E,F=F,G=G,H=H,A=A,B=B,jmp=0.5, sdB=1)$X
pairs(xs,pch=".",cex=2,upper.panel=NULL,diag.panel=panel.dens)


###################################################
### chunk number 21: figu3
###################################################
panel.dens <- function(x, ...)
{
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(usr[1:2], 0, 1.5) )
    DD <- density(x); DD$y<- DD$y/max(DD$y)
    polygon(DD,col="grey")
}
xs <- xsample(E=E,F=F,G=G,H=H,A=A,B=B,jmp=0.5, sdB=1)$X
pairs(xs,pch=".",cex=2,upper.panel=NULL,diag.panel=panel.dens)


###################################################
### chunk number 22: linp
###################################################
E <- matrix(ncol=4, byrow=TRUE,
            data=c(3,2,1,4,1,1,1,1))
F <- c(2,2)

G <-matrix(ncol=4,byrow=TRUE,
           data=c(2,1,1,1,-1,3,2,1,-1,0,1,0))
H <- c(-1, 2, 1)
Cost <- c(1,2,-1,4)
linp(E,F,G,H,Cost)


###################################################
### chunk number 23: linp 2
###################################################
LP <-linp(E=E,F=F,G=G, H= H, Cost=Cost, ispos=FALSE)
LP$X
LP$solutionNorm


